#!/usr/bin/ruby

def replaceAll(line, subst)
	subst.each do |sub,rep|
		line = line.gsub('{' + sub + '}', rep)
	end
	
	return line
end

def degenerateCaps(text)
	text = text.gsub(/[A-Z]+[a-z]+/) do |s|
		s.downcase + '_'
	end
	
	return text[0..-2]
end

subst = {}
name = ARGV[0]

if (name == nil) then
	print "Class name (capitalized): "
	name = gets[0..-2]
end

subst['template_'] = degenerateCaps(name)
subst['template-'] = subst['template_'].sub('_', '-')
subst['TEMPLATE'] = subst['template_'].upcase
subst['Template'] = name

tc = IO.readlines("template.c")
th = IO.readlines("template.h")

f = File.open('gm-' + subst['template-'] + '.c', 'w')
tc.each do |line|
	f.write(replaceAll(line, subst))
end
f.close

f = File.open('gm-' + subst['template-'] + '.h', 'w')
th.each do |line|
	f.write(replaceAll(line, subst))
end
f.close

print "Done ...\n"
